Subject: Re: [ofa-general] Re: [PATCH v4 14/14] QLogic VNIC: sysfs Documentation

From: Patrick McHardy <[email-masked]>
Date: Sat, 14 Jun 2008 10:08:08 +0200

Amar Mudrankit wrote:
>> If you have questions, feel free to ask.
>>
> I was trying to guess the use case for the vlan which has implemented
> rtnl_link api :
> 
> For sending parameters to driver:
> # ip link set <vlan-iface-name> up multicast ...... type vlan id
> <vlan-id> reorder_hdr on
> 
> ingress-qos-map <...> egress-qos-map <...>
> 
> In such case, I think the link_util's private parse_opt function will
> be invoked to parse link's private configurable parameters.  These
> parameters along with the standard set of parameters (name, multicast,
> promisc etc) are then sent to driver through rtnl_talk function .
> 
> Similarly, for reading values from driver:
> 
> # ip addr show dev <vlan-iface-name>
> 
> does it require "type" field similar to "ip link set"?

No. Thats only required for parsing device specific parameters.

> Is this understanding correct?

Yes.

> How does a link type corresponding to VLAN driver gets added into
> linkutil_list, so that ip will correctly call functions specific to
> VLAN driver?

iproute dlopens itself and looks for the struct "<type>_link_util".

>> You can dump driver private statistics in the ->fill_xstats function.
>>
> 
> I was looking at latest release of iproute2, in which I could not
> locate fill_xstats. Can you help me to locate this?

->fill_xstats is in the kernel, in iproute its ->print_xstats.